<?php
/**
* @version      2.8
* @package		EasyTagCloud
* @author       Qi Huang
* @copyright	Copyright(C)2015 Qi Projects. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Easytagcloud is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modTagcloudhelper 
{
 public function getTags($params, $moduleid) {
          global $mainframe;
          $db = JFactory :: getDBO();
		  $user = JFactory::getUser();
		  $groups = implode(',', $user->getAuthorisedViewLevels());
	      $document = JFactory::getDocument();		 		    
		  $limit = $params->get('maxtags');	
          $selectedtags = $params->get('tags');		  
          $tags = new stdClass();
          $count = array();	
          $tags->size = array();
          $tags->color = array();
          $tags->id = array();
          $tags->alias = array();
          $tags->moduleid = $moduleid;	  
	      $query = $db->getQuery(true)
			 ->select(
				 array(
				   	$db->quoteName('m.tag_id') . ' AS tag_id',
					$db->quoteName('t.access') . ' AS access',
					$db->quoteName('t.alias') . ' AS alias',
					$db->quoteName('t.path') . ' AS path',					
					$db->quoteName('t.title') . ' AS title',	
					$db->quoteName('t.parent_id') . ' AS parent_id',					
					$db->quoteName('m.type_alias') . ' AS type_alias',
					$db->quoteName('c.core_catid') . ' AS catid'
				 )
			 )
			 ->from($db->quoteName('#__contentitem_tag_map') . ' AS m')
			 ->where($db->quoteName('t.access') . ' IN (' . $groups . ')');
		// Only return accessible content, since v2.8
		$query->where($db->quoteName('c.core_access') . ' IN (' . $groups . ')');			
		// Only return published tags
		$query->where($db->quoteName('t.published') . ' = 1 ');
		// Only return published content, since v2.8
		$query->where($db->quoteName('c.core_state') . ' = 1 ');
	
		
		// Optionally filter on language
		$language = JComponentHelper::getParams('com_easytagcloud')->get('tag_list_language_filter', 'all');

		if ($language != 'all')
		{
			if ($language == 'current_language')
			{
				$language = JHelperContent::getCurrentLanguage();
			}
			$query->where($db->quoteName('t.language') . ' IN (' . $db->quote($language) . ', ' . $db->quote('*') . ')');
		}		
		 $query->join('INNER', $db->quoteName('#__tags', 't') . ' ON m.tag_id = t.id')
			->join('INNER', $db->quoteName('#__ucm_content', 'c') . ' ON m.type_alias = c.core_type_alias AND m.core_content_id = c.core_content_id');

		 $db->setQuery($query);			  	 
		 //echo  $query->__toString(); 
		 //exit;
         $results = $db->loadObjectlist();	 
     	 
		 $filteredarray = Array();		  
		 $tmparray = Array();
		 $categoriesfilter = $params->get('categoriesfilter');	
		 // filtered by selected tags and categories, since v2.8
		 foreach ($results as $result) {
            if (empty($selectedtags) || in_array($result->tag_id, $selectedtags)) {
			    $type_alias = explode("." , $result->type_alias);
			    $cat_alias = $type_alias[0].'.'.$result->catid;
			    if (empty($categoriesfilter) || in_array($cat_alias, $categoriesfilter)) { 
                    if (array_key_exists($result->title, $tmparray)) {
				          $tmparray[$result->title]->count ++;			     
				    } else {
			              $tmparray[$result->title] = new stdClass();
						  $tmparray[$result->title]->count = 1;
						  $tmparray[$result->title]->id = $result->tag_id;
						  $tmparray[$result->title]->alias = $result->alias;						  
				    }			 
			    }
		    }		 
		 }

		  $i = 0;  
		  $params->get('randomtags') ? self::shuffle_assoc($tmparray) : arsort($tmparray);			  
		  foreach ($tmparray as $k => $v) {		 
		    $filteredarray[$i] = new stdClass();
			$filteredarray[$i]->tag = $k;
			$filteredarray[$i]->count = $v->count;
			$filteredarray[$i]->id = $v->id;
			$filteredarray[$i]->alias = $v->alias;						
			$i++;
			if ($i == $limit) {
			    break;
			}
		 }
         unset($tmparray);
		 
         // set the tags order. since v2.3
		 $sortresult = self::tagSort($filteredarray, $params->get('tagsorder')); 		 
         foreach ($sortresult as $a) {
            $tags->count[$a->tag] = $a->count;	
			$tags->id[$a->tag] = $a->id;
			$tags->alias[$a->tag] = $a->alias;				        
            
         }
         $tags->notag = empty($tags->count) ? true : false;	// since v2.4.3	 
		 
         $min_count = $tags->notag ? 0 : min($tags->count);
		 $max_count = $tags->notag ? 0 : max($tags->count);		 
	     $spread = $max_count - $min_count;	 

	     if ( $spread <= 0 )
	          $spread = 1;
	     $font_spread = $params->get('maxfontsize') - $params->get('minfontsize');
	     if ( $font_spread < 0 )
	          $font_spread = 1;
	     $font_step = $font_spread / $spread;		 
		 foreach( $sortresult as $result ) {  
	        $tags->size[$result->tag] = (int)($params->get('minfontsize') + (($result->count - $min_count) * $font_step));   // algorithmn change from v2.4
			$tags->color[$result->tag] = $params->get('colorfultags') ? "color:#".dechex(rand(0,16777215)) : "";
         }	    														 
		$tags->align = $params->get('align').';';
	    $tags->target = $params->get('target');	
	    // set colorful tags
	    $tags->colorfultags = $params->get('colorfultags');	

        $tags->displaycount = $params->get('displaycount');	
		
		// enable google fonts, since v2.4.3
        if ($params->get('googlefont') != '') {
		    $family = JString::str_ireplace(' ', '+', JString::trim($params->get('googlefont')));
		    $subset = $params->get('scriptsubset') == '' ? '' : '&subset='.$params->get('scriptsubset');
			$effect = $params->get('googlefonteffect') == '' ? '' : '&effect='.JString::substr($params->get('googlefonteffect'), 12);
		    $document->addStyleSheet('http://fonts.googleapis.com/css?family='.$family.$subset.$effect);
			$googlefont = $params->get('googlefont');
			$tags->googlefonteffect = $params->get('googlefonteffect') == '' ? '' : 'class="'.$params->get('googlefonteffect').'"';
	    } else {
			$googlefont = $tags->googlefonteffect = "";		
		}
        

		// build css codes in head, since v2.5	
							    
		$css['']['width'] = $params->get('width');
		$css['']['height'] = $params->get('height'); 
		$css['']['text-align'] = $params->get('align');		
		$css['']['line-height'] = $params->get('lineheight'); 		
		$css['a']['margin-left'] = $params->get('horizontalspace'); 
		$css['a']['margin-right'] = $params->get('horizontalspace'); 
		$css['a']['padding'] = $params->get('tagspadding');
		$css['a']['-webkit-border-radius'] = $params->get('borderradius'); 
		$css['a']['-moz-border-radius'] = $params->get('borderradius'); 
		$css['a']['border-radius'] = $params->get('borderradius'); 		
		$css['a']['font-family'] = $googlefont; 
	    $css['a:link']['text-decoration'] = $params->get('showunderline');
	    $css['a:link']['color'] = $params->get('tagscolor');	
	    $css['a:link']['background-color'] = $params->get('tagsbgcolor');
	    $css['a:link']['font-weight'] = $params->get('bold');
	    $css['a:visited']['text-decoration'] = $params->get('showunderline');
	    $css['a:visited']['color'] = $params->get('tagscolor');	
	    $css['a:visited']['background-color'] = $params->get('tagsbgcolor');
	    $css['a:visited']['font-weight'] = $params->get('bold');		
	    $css['a:hover']['text-decoration'] = $params->get('hovershowunderline');
	    $css['a:hover']['color'] = $params->get('tagshovercolor');	
	    $css['a:hover']['background-color'] = $params->get('tagshoverbgcolor');
		
        self::cssBuilder($css, $moduleid);
        return $tags;
 }

 public function tagSort($result, $type) {
           $sort_array = Array();
	       $sort_array2 = Array();
	       $sort_array3 = Array();	
	       $merge_array = Array();
	       if($type == 1) {
	          return $result; //no need to sort
	       }else {
              foreach($result as $r) {
	             $sort_array[] = $r->tag;
	             $sort_array2[] = $r->tag;		
			     $sort_array3[] = $r->count;	
		      }			      
	       }	      	
	      if($type == 0) {  //sort by tag name
		     natcasesort($sort_array);
	         foreach($sort_array as $i=>$a) {    
               $merge_array[] = $result[$i];
	         }			   
	       }
	       elseif($type == 2) { //sort by most tagged first
		       natcasesort($sort_array3);
	           foreach($sort_array3 as $i=>$a) {
		       $merge_array[] = $result[$i];
	           }		
	       }
	       elseif($type == 3) { //sort randomly
		       shuffle($sort_array2);
	           foreach($sort_array2 as $a) {
	           $key = array_keys($sort_array, $a);
		       $merge_array[] = $result[$key[0]];
	           }		  
	       }
	      return $merge_array;
       }

     // build css codes in Head (from v2.5)	
  public function cssBuilder($blocks, $moduleid) {
	       $document = JFactory::getDocument();	
	       $css = '';
           foreach ($blocks as $block_k => $block_v) { 
	                $css .= '#easytagcloud_'.$moduleid.' '.$block_k.'{';
			        foreach ($block_v as $attr_k => $attr_v) {
			                 if ($attr_v == '') continue;
			                 $css .= $attr_k.':'.$attr_v.';';
			        }
			        $css .= '}';			       	
	        }
	        $document->addStyleDeclaration($css);	
  }
 
  public function shuffle_assoc(&$array) {
           $keys = array_keys($array);
           shuffle($keys);
		   $randomized_array = Array();
           foreach ($keys as $key) {
		            $randomized_array[$key] = $array[$key];
		   }
		   $array = Array();
		   foreach ($randomized_array as $k => $v) {
                    $array[$k] = $v;
		   }		   
  }
}
?>
