<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_easytagcloud
 * @copyright   Copyright (C) 2015 http://www.huangqiprojects.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

	/**
	 * Build the route for the com_easytagcloud component
	 *
	 * @param   array  &$query  An array of URL arguments
	 *
	 * @return  array  The URL arguments to use to assemble the subsequent URL.
	 *
	 * @since   2.8
	 */
	function EasyTagCloudBuildRoute(&$query)
	{
		$segments = array();

		if (isset($query['mid']))
		{
		    $segments[] = $query['mid'].'-module';
			unset($query['mid']);
		}	
		
		if (isset($query['id']))
		{		
		    $segments[] = $query['id'];
			unset($query['id']);
		}	      
		// view and itemid are no needed
		unset($query['view']);
		unset($query['itemid']);
		
		
		$total = count($segments);
		
	
		
		for ($i = 0; $i < $total; $i++)
		{
			$segments[$i] = str_replace(':', '-', $segments[$i]);
		}
		return $segments;
	}

	/**
	 * Parse the segments of a URL.
	 *
	 * @param   array  &$segments  The segments of the URL to parse.
	 *
	 * @return  array  The URL attributes to be used by the application.
	 *
	 * @since   3.3
	 */
	function EasyTagCloudParseRoute(&$segments)
	{
		$total = count($segments);
		$vars = array();

		for ($i = 0; $i < $total; $i++)
		{
			$segments[$i] = preg_replace('/-/', ':', $segments[$i], 1);
		}

		$vars['mid'] = (int)$segments[0]; 
		$vars['id'] = $segments[1];
		return $vars;
	}
